/*
SSHMeIn's javascript code for RIA interface events
Make use of javascript object pattern like all modern javascript framework
This library make intensive use of jquery library
*/


var sshmein = {

	/* Set this variable to URL of your application */
	application_url : window.location.protocol + '//' + window.location.host + '/',
	
	init: function(){
		
		/*
		Starting SSHMeIn interface after DOM is ready
		*/	
		$('#loadingDiv').dialog({modal:true, resizable:false, title: 'Loading Content', height:100, width:400}).show();
		$('#switcher').themeswitcher({loadTheme: 'Dot Luv'});
		sshmein.binding.effects();
		sshmein.binding.events();
		sshmein.group.load();
	},//init()

	binding: {
		
		/*
		Managin all bindings (effects, events) here
		*/
		effects: function(){
			/*
			Hover effect for the logout button
			*/
			
			$('#logout, button').hover(function(){
				$(this).addClass('ui-state-hover');
			}, function(){
				$(this).removeClass('ui-state-hover');
			});
			
		},//binding.effects()
		
		events: function(){
			
			/*
			Binding logout event to logout button
			*/
			$('#logout').click(function(){
				console.log('Closing');
			});
			
			/*
			Binding click 'New group' button
			*/
			$('button#new_group').click(function(){
				if (!$('#group_n').length){
					sshmein.group.add();
				}
			});
		},//binding.events()
		
		editable: function(){
				$('.edit_hostname').editable(function(value, settings){
					$.post(sshmein.application_url + 'hosts/update', {'hostname' : value, 'id' : this.id.substring(9)}, 
						function(data){
							//If callback successfull  
							$('img#delete_' + data).attr('title', 'Delete ' + value);
							$('img#download_'+data).attr('title', "Download tunnel's client for " + value);
							
							//if is an ON tunnel we change name in the sidebar_info
							el = $('div#sidebar_info li#' + data + ' a');
							if (el){
								el.html(value.htmlEntities());
							}
						}, 'text'
					);
					
					return value.htmlEntities();
					
					},
					{
					name : 'hostname',
					onblur : 'submit',
					tooltip : 'Click to edit hostname',
					style: "display:inline",
					cssclass: "hostname",
					width: "none"
					}
				);		
			
				$('.edit_gateway_tunnel').editable(sshmein.application_url + 'hosts/update',{
					name : 'gateway_host',
					onblur : 'submit',
					tooltip : 'Click to edit tunnel gateway',
					style: "display:inline"
				});
				
				$('.edit_gateway_port').editable(sshmein.application_url + 'hosts/update',{
					name : 'gateway_port',
					onblur : 'submit',
					tooltip : 'Click to edit the tunnel gateway port',
					style: "display:inline"
				});		
				
				$('.edit_gateway_user').editable(sshmein.application_url + 'hosts/update',{
					name : 'gateway_user',
					onblur : 'submit',
					tooltip : 'Click to edit the tunnel gateway user',
					style: "display:inline"
				});
				
				$('.edit_authorized_ip').editable(sshmein.application_url + 'hosts/update',{
					name : 'authorized_ip',
					onblur : 'submit',
					tooltip : 'Click to edit the authorized IP',
					style: "display:inline"
						
				});				
		}
		
	},//binding


	notifiate : function(msg, delay){
		if(delay === 0){
			delay = false;
		}else{
			delay = delay || 3; // default 3 secondes
		}
		
		flash = $('#flash');
		
		$('#flash').html(msg.htmlEntities());
		flash.slideDown();
		
		if (delay){
			$('#flash').animate({opacity:1.0}, delay*1000); // tricks for delaying next event
			$('#flash').slideUp();
		}	
	},//notifiate()

	searchHost: function(elem){
		group = $(elem).parent().attr('class');
		groupEl = $('#' + group);
		index = $('div#groups').children().index(groupEl);
		//If panel is not already active ... activate it!
		if (!groupEl.find('h3').hasClass('ui-state-active')){
			$('#groups').accordion('activate',index);
		}
	},
	
	group: {
		add: function(){
			
			//Closing all panel
			$('#groups').accordion('activate', -1);
			$('#groups div h3.ui-state-active').removeClass('ui-state-active').addClass('ui-state-default');
			$('#groups h3 span.ui-icon-triangle-1-s').removeClass('ui-icon-triangle-1-s').addClass('ui-icon-triangle-1-e');
			
			//Adding new group in UI
			data ={'name':'groupname here', id:'n', description: 'Click to edit the group description'}
			$('#groupTemplate').tmpl(data).prependTo('#groups');
			
			$('div#group_n h3').addClass('ui-accordion-header ui-helper-reset ui-state-active ui-corner-top');
			$('div#group_n h3').html('<span class="ui-icon ui-icon-triangle-1-s"/><span class="tunnel"></span><a href="#"><input type="text" name="groupname" value="groupname here"/></a>');
    		$('div#group_n div.hosts').addClass('ui-accordion-content ui-helper-reset ui-widget-content ui-corner-bottom ui-accordion-content-active');					
					
            /*
            Manage event for groupname input
            Trigger saving on blur event
            Add editinplace for groupname and groupdescription
            */
            
            $('#group_n input').focus().select().blur(
                function(){
                    /*
                     groupname onBlur POST
                    */
                    var newgroup = $('#group_n input').val();
                    newgroup = newgroup.trim();
                    
                    if (newgroup.length === 0){
                     newgroup = 'Please name me';
                    }
                    
                    $.post(sshmein.application_url + 'groups/new',{ groupname: newgroup},
                        /*
                        POST callback function
                        */

                        function(data){

                            sshmein.notifiate('New group created');
                            lastid = data;
                            
                            /*
                            Replacing input with span after successfull saving
                            */
                            $('div#group_n input').remove();
                            $('div#group_n h3 > a').append('<span class="editgroupname" id="' + lastid + '">' + newgroup.htmlEntities() + '</span>');
                            
                            //Updating the new group class with his name
                            $('div#group_n').attr('class', newgroup);
                            
                            //Setting Group ID on new Host button
                            $('#btn_new_host_n').attr('id', 'btn_new_host_' + lastid);	
                            var newGroupID = '#group_' + lastid;
                            $('#group_n').attr('id', 'group_' + lastid);
                            $('div' + newGroupID + ' p.editgroupdescription').attr('id', lastid);
                            
                            //Settings title and id on delete group image link
                            $('a#delgroup_n').attr('title', 'Delete group ' + newgroup);
                            $('a#delgroup_n').attr('id', 'delgroup_' + lastid);
                            
                            /*
                            Binding editinplace for groupname
                            */
                            $(newGroupID + ' span.editgroupname').editable(sshmein.application_url + 'groups/update',
                                {
                                    name : 'groupname',
                                    onblur : 'submit',
                                    style : 'width: 200px;',
                                    tooltip : 'Double click to edit the group name',
                                    width: 'none',
                                    event: 'dblclick'
                                }
                            );
                            
                            /*
                            Binding editinplace for group description
                            */
                            $(newGroupID  + ' p.editgroupdescription').editable(sshmein.application_url + 'groups/update',
                                {
                                    name : 'description',
                                    type : 'textarea',
                                    rows : 3,
                                    submit: 'OK',
                                    tooltip : 'Click to edit the group description'
                                }
                            );
                            
                            $('#groups').accordion('destroy');
                            $("#groups").accordion({ header: "h3", active: false, alwaysOpen: false, autoHeight:false, clearStyle: true, collapsible: true });
			    index = $('#groups').children().index($(newGroupID));
                            $('#groups').accordion('activate', index);
                            
                        },'text');
                    }	
                );//groupname blur
		},//group.add()
		
		remove : function(id){

			groupID = id.substring(9);
			groupEl = $('div#group_' + groupID);
			title = groupEl.attr('class');
			
			//Requesting confirmation before deleting
			resp = confirm('Are you sure you want to delete permanently\nthe group "' + title + '" and all his hosts?\n\nYou will not be able to access any computer of this group after the deletion');
			
			if (resp){
				//Delete in database
				$.get(sshmein.application_url + 'groups/delete/' + groupID);
				
				
				//Removing the hosts of this group from the sidebar 
				//and updating the tunnel's ON counter 
				hostsON = $('div#sidebar_info li.' + id.substring(3));
				sshmein.sidebar.decreaseCounter(hostsON.length);
				hostsON.remove();
							
				//Removing host from interface
				$('div#group_' + groupID).remove();
				
				sshmein.notifiate('Deletion of group ' + title + ' OK!');
			}
		},//group.remove()
		

		load: function(){
			var counterTunnelOn = [];
			counterTunnelOn[0] = 0;

			//Fetching and loading all groups
			$.get(sshmein.application_url + "groups/",
				function(data){
					if (data.length != undefined){
						$('#groupTemplate').tmpl(data).appendTo('#groups');
					
					    $.each(data, function(index, group) { 
    						counterTunnelOn[group.id] = 0;
        	            });
					}				                        
					
					$("#groups").accordion({header: "h3", active: false, alwaysOpen: false, autoHeight:false, clearStyle: true, collapsible: true });
						
					$('.editgroupname').editable(function(value, settings){
					
						groupid = this.id;
						
						$.post(sshmein.application_url + 'groups/update', {'groupname' : value, 'id' : this.id}, 
							function(data){
								//If callback successfull
								
								//if is has host's tunnel ON ... we update the title on host
								//in the sidebar for the tooltips
								el = $('div#sidebar_info li.group_' + groupid);
								if (el){
									el.attr('title', value);
								}
								
								//we update the group class with the new group name
								$('div#group_' + groupid).attr('class', value);
							}
						);
						
						return value.htmlEntities();
						
						},
						{
						name : 'groupname',
						onblur : 'submit',
						style : 'width: 200px;',
						tooltip : 'Doubleclick to edit the group name',
						width: 'none',
						event: 'dblclick'
						
					});			
					
					
					$('.editgroupdescription').editable(sshmein.application_url + 'groups/update',{
						name : 'description',
						type : 'textarea',
						rows : 3,
						submit: 'OK',
						tooltip : 'Click to edit the group description'
					});
					
					//Reset view all
					$('#groups h3').click(function(){
						$('dl.host').show();
						$('div.filter').find(".ui-state-active").removeClass("ui-state-active");
						$('div.filter button.view_all').addClass('ui-state-active');				
						
					});
					
					//Binding evens for delete group image
					$('#groups').delegate('a.delgroup', 'click', function(){
						sshmein.group.remove($(this).attr('id'));
					});
					
					//Binding event for New host button   
					$('#groups').delegate('button.new_host', 'click', function(){
						sshmein.host.add($(this).attr('id'));
					});
					
					
					//Binding event for view buttons
					$('#groups').delegate('button.view_all', 'click', function(){
						$('dl.host').show();
						$(this).parents('.filter:first').find(".ui-state-active").removeClass("ui-state-active");
						$(this).addClass('ui-state-active');				
					});
					
					$('#groups').delegate('button.view_on', 'click', function(){
						$('dl.tunnel_on').show();
						$('dl.tunnel_off').hide();
						$(this).parents('.filter:first').find(".ui-state-active").removeClass("ui-state-active");
						$(this).addClass('ui-state-active');
					});
					
					$('#groups').delegate('button.view_off', 'click', function(){
						$('dl.tunnel_off').show();
						$('dl.tunnel_on').hide();
						$(this).parents('.filter:first').find(".ui-state-active").removeClass("ui-state-active");
						$(this).addClass('ui-state-active');
					});
					
					//Loading all hosts
					sshmein.host.load(counterTunnelOn);

			},'json');
			
				
		},//load()		
		
		tunnelTurnOFF: function(element){
			host = $(element).parents('dl:first');
			host.attr('class', 'host tunnel_off');
			hostID = host.attr('id');
			id = hostID.substring(5); //We substring 'host_' to get the host ID
				
			//Settings tunnel ON in database
			$.post(sshmein.application_url + 'hosts/update', {'tunnel_status' : 'OFF', 'id' : id}, function(data){
			
				if (data){
					//Changing image attributes
					$(element).attr('src', 'static/images/tunnel_off.png');
					$(element).attr('class', 'tunnel tunnel_off');
					$(element).attr('title', 'Tunnel is OFF (Click to turn ON)');
					
							
					//Updating the sidebar
					sshmein.sidebar.update('down', id);
			
					//Updating the group counter
					group = host.parents('div:eq(1)');
					tunnel_msg = group.find('span.tunnel');
					if (tunnel_msg.html() != ''){
						current_count = tunnel_msg.find('span').html();
						newcount = parseInt(current_count, 10) - 1;
						
						if (newcount > 0 ){
							tunnel_msg.find('span').html(newcount);
						}else{
							tunnel_msg.html('');
						}
					}
					
					//Notification
					sshmein.notifiate('Turning OFF tunnel OK!');
				}
			});
		},//tunnelTurnOFF()
		
		tunnelTurnON: function(element){
			host = $(element).parents('dl:first');
			host.attr('class', 'host tunnel_on');
			hostID = host.attr('id');
			id = hostID.substring(5); //We substring 'host_' to get the host ID
			
			//Settings tunnel ON in database
			$.post(sshmein.application_url + 'hosts/update', {'tunnel_status' : 'ON', 'id' : id}, function(data){
			
				if (data){
					//Changing image attributes
					$(element).attr('src', 'static/images/tunnel_on.png');
					$(element).attr('class', 'tunnel tunnel_on');
					$(element).attr('title', 'Tunnel is on (Click to turn OFF)');

					//Updating the group counter
					group = host.parents('div:eq(1)');
					tunnel_msg = group.find('span.tunnel');		
					if (tunnel_msg.html() != ''){
						current_count = tunnel_msg.find('span').html();
						newcount = parseInt(current_count, 10) + 1;
						tunnel_msg.find('span').html(newcount);
					}else{
						tunnel_msg.html('Tunnel ON: <span>1</span>');
					}
					
					//Updating the sidebar
					sshmein.sidebar.update('up', id, group);
					
					//Notification
					sshmein.notifiate('Turning ON tunnel OK!');
				}
			});		
		}//tunnelTurnON()
	},//group
	
	host:{
		add: function(element){
			
			group_id = element.substring(13); //removing part 'btn_new_host_' for getting group ID
			
			/*
			Loading html content
			*/
			$.get(sshmein.application_url + 'hosts/new/' + group_id, 
				/*
				GET callback function
				*/
				function(data)
				{
				    host={}
					host.img_title = 'Tunnel is OFF (Click to turn ON)';
					host.img_src = 'tunnel_off.png';
					host.style_class = 'tunnel_off';
					host.hostname = 'New host';
					host.id = data.id;
					host.tunnel_key = data.tunnel_key;
					
					$('#hostTemplate').tmpl(host).insertAfter('#group_' + group_id + ' div.hosts div.ui-widget-header');
					sshmein.binding.editable();
				}, 'json'
			);
		},
		
		remove: function(element){
			id = element.substring(7);
			title = $('div.hosts span#hostname_' + id).html();
			
			//Requesting confirmation before deleting
			resp = confirm('Are you sure you want to delete permanently\nthe host "' + title + '"?');
			
			if (resp){
				//Delete in database
				$.get(sshmein.application_url + 'hosts/delete/' + id);
				
				hostEl = $('dl#host_' + id);
				
				//Updating the sidebar
				sshmein.sidebar.update('down', id);
				
				//Group tunnel ON's count
				group = hostEl.parents('div:eq(1)');
				tunnel_msg = group.find('span.tunnel');
				
				current_count = tunnel_msg.find('span').html();
				newcount = current_count - 1;
					
				if (newcount > 0 ){
					tunnel_msg.find('span').html(newcount);
				}else{
					tunnel_msg.html('');
				}
							
				//Removing host from interface
				hostEl.remove();
				
				//Notification
				sshmein.notifiate('Deleting host ' + title + ' OK!');
			}
		},//remove()		
			
			
		load: function(counterTunnelOn){	

			//Fetching and loading all hosts
			$.get(sshmein.application_url + "hosts/",
				function(data){

					var totalTunnelOn = 0;
					var hostsOn = [];
						
					for (var row in data){

						if (data[row].tunnel_status.toUpperCase() == 'ON'){
							img_title = 'Tunnel is ON (Click to turn OFF)';
							img_src = 'tunnel_on.png';
							style_class = 'tunnel_on';
							counterTunnelOn[data[row].group_id] += 1;
							hostsOn[data[row].id] = {'name' : data[row].hostname, 'groupid' : data[row].group_id}; 
						}else{
							img_title = 'Tunnel is OFF (Click to turn ON)';
							img_src = 'tunnel_off.png';
							style_class = 'tunnel_off';
						}
						
						groupid = '#group_' + data[row].group_id;
						
						data[row].style_class = style_class;
						data[row].img_title = img_title;
						data[row].img_src = img_src;
						
						$('#hostTemplate').tmpl(data[row]).appendTo(groupid + ' div.hosts');
					}
					
					for(var k in counterTunnelOn){
						if (counterTunnelOn[k] > 0){
							totalTunnelOn += counterTunnelOn[k];
							txt = '<span class="tunnel">Tunnel ON: <span>' + counterTunnelOn[k] + '</span></span>';
						}else{
							txt = '<span class="tunnel"></span>';
						}
						
						$('#group_' + k + ' h3').prepend(txt);	
					}
					
					sidebarInfo = '<p id="tunnel_on_count"><span>' + totalTunnelOn + '</span> tunnels are ON</p><ul>';
					for(var j in hostsOn){
						sidebarInfo += '<li id="' + j + '" class="group_'+ hostsOn[j].groupid +'" title="' + $('#group_' + hostsOn[j].groupid).attr('class') + '"><a href="#">' + hostsOn[j].name + '</a></li>';
					}
					
					sidebarInfo += '</ul>';
					
					$('#sidebar_info').empty().html(sidebarInfo);
					
					$('#sidebar_info').delegate('a','click', function(){
						sshmein.searchHost(this);
					});
					
					$('#groups').delegate('img.tunnel_on', 'click', function(){
						sshmein.group.tunnelTurnOFF(this);
					});
					
					$('#groups').delegate('img.tunnel_off', 'click', function(){
						sshmein.group.tunnelTurnON(this);
					});
					
					$('#groups').delegate('img.delete', 'click', function(){
						sshmein.host.remove($(this).attr('id'));
					});
					
					
				$('#loadingDiv').dialog('destroy');	
		
				//Binding edit in place for host parameters
				sshmein.binding.editable();
				
	
			},'json');
		}//load()
    },//host
    
    
    sidebar:{
        update : function(direction, id, group){
		
			if (!direction || !id){
			  return;
			}
			
			groupEl = $(group);
			group_id = groupEl.attr('id');
			group_name = groupEl.attr('class');
			
			tunnel_on_count = $('p#tunnel_on_count span');
			current_count = parseInt(tunnel_on_count.html(), 10);
			
			if (direction == 'up'){
				li = $('div#sidebar_info li#' + id);
				
				if (li.length === 0){
					hostname = $('span#hostname_' + id).html();
					$('div#sidebar_info ul').append('<li id="' + id + '" class="'+group_id+'" title="' + group_name + '"><a href="#">' + hostname + '</a></li>');
					tunnel_on_count.html(current_count + 1);
				}
			}else if (direction == 'down'){
				li = $('div#sidebar_info li#' + id);
				
				if (li.length == 1){
					li.remove();
						
					if (current_count > 0){
						tunnel_on_count.html(current_count - 1);
					}	
				}
			}

		},//update()
	
		decreaseCounter : function(value){
			tunnel_on_count = $('p#tunnel_on_count span');
			current_count = parseInt(tunnel_on_count.html(), 10);
			tunnel_on_count.html(current_count - value);
		}	
	},//sidebar
	
	time:{
	
		format: function(unixstamp){
		        if (unixstamp){
			   var stamp = new Date(parseInt(unixstamp, 10) * 1000);
			   return stamp.toLocaleString();
			}else{
			   return '';
			}
		}//format()
	}
	
};//sshmein

